diff --git a/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java b/game/core/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java
similarity index 98%
rename from src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java
rename to game/core/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java
index 5d3d8efe9..a07009f13 100644
--- a/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java
@@ -41,7 +41,7 @@ public class LoggedPrintStream extends PrintStream
 		boolean a = false;
 		for(int i=0; i < string.length(); i++) {
 			char c = string.charAt(i);
-			if(c == '§') {
+			if(c == '\u00a7') {
 				a = true;
 			}else if(a) {
 				a = false;
diff --git a/src/main/java/net/minecraft/core/util/phys/AABB.java b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
similarity index 98%
rename from src/main/java/net/minecraft/core/util/phys/AABB.java
rename to game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
index d1fcf3616..55acecb25 100644
--- a/src/main/java/net/minecraft/core/util/phys/AABB.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
@@ -16,9 +16,9 @@ public class AABB
     public double maxY;
     public double maxZ;
 
-    public static AABB getPermanentBB(double d, double d1, double d2, double d3, double d4, double d5)
+    public static AABB getPermanentBB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
     {
-        return new AABB(d, d1, d2, d3, d4, d5);
+        return new AABB(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
     public static void deinitializePool()
diff --git a/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
similarity index 98%
rename from src/main/java/net/minecraft/core/world/BlocksContainer.java
rename to game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index 397297255..b4ad36886 100644
--- a/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
@@ -55,7 +56,7 @@ public class BlocksContainer implements WorldSource {
 
     @Override
     public Block getBlock(int x, int y, int z) {
-        return Block.getBlock(getBlockId(x, y, z));
+        return Blocks.getBlock(getBlockId(x, y, z));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
similarity index 94%
rename from src/main/java/net/minecraft/core/world/Explosion.java
rename to game/core/src/main/java/net/minecraft/core/world/Explosion.java
index f48cd58b7..43fc7e8c4 100644
--- a/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -88,9 +88,9 @@ public class Explosion {
             }
             if(id > 0)
             {
-                Block.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
+                Blocks.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
                 worldObj.setBlockWithNotify(x, y, z, 0);
-                Block.blocksList[id].onBlockDestroyedByExplosion(worldObj, x, y, z);
+                Blocks.blocksList[id].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
         }
     }
@@ -124,7 +124,7 @@ public class Explosion {
                         int l4 = MathHelper.floor(d9);
                         int i5 = worldObj.getBlockId(j4, k4, l4);
                         if(i5 > 0) {
-                            f1 -= (Block.blocksList[i5].getBlastResistance(exploder) + 0.3F) * f2;
+                            f1 -= (Blocks.blocksList[i5].getBlastResistance(exploder) + 0.3F) * f2;
                         }
                         if(f1 > 0.0F) {
                             destroyedBlockPositions.add(new ChunkPosition(j4, k4, l4));
@@ -180,7 +180,7 @@ public class Explosion {
 			int y1 = chunkposition.y;
 			int z1 = chunkposition.z;
 			
-			if(worldObj.getBlockId(x1, y1, z1) == 0 && Block.solid[worldObj.getBlockId(x1, y1 - 1, z1)] && ExplosionRNG.nextInt(3) == 0) {
+			if(worldObj.getBlockId(x1, y1, z1) == 0 && Blocks.solid[worldObj.getBlockId(x1, y1 - 1, z1)] && ExplosionRNG.nextInt(3) == 0) {
 				worldObj.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id);
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
similarity index 88%
rename from src/main/java/net/minecraft/core/world/ExplosionCannonball.java
rename to game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 8c6c0079b..2faa0280b 100644
--- a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -61,7 +61,7 @@ public class ExplosionCannonball extends Explosion{
                         int i5 = worldObj.getBlockId(j4, k4, l4);
                         if(i5 > 0)
                         {
-                            f1 -= (Block.blocksList[i5].getBlastResistance(exploder) + 0.3F) * f2;
+                            f1 -= (Blocks.blocksList[i5].getBlastResistance(exploder) + 0.3F) * f2;
                         }
                         if(f1 > 0.0F)
                         {
@@ -121,7 +121,7 @@ public class ExplosionCannonball extends Explosion{
                 int k3 = chunkposition.z;
                 int l3 = worldObj.getBlockId(i3, j3, k3);
                 int i4 = worldObj.getBlockId(i3, j3 - 1, k3);
-                if(l3 == 0 && Block.solid[i4] && ExplosionRNG.nextInt(3) == 0)
+                if(l3 == 0 && Blocks.solid[i4] && ExplosionRNG.nextInt(3) == 0)
                 {
                     worldObj.setBlockWithNotify(i3, j3, k3, Blocks.FIRE.id);
                 }
@@ -165,16 +165,16 @@ public class ExplosionCannonball extends Explosion{
                 worldObj.spawnParticle("explode", (d + explosionX) / 2D, (d1 + explosionY) / 2D, (d2 + explosionZ) / 2D, d3, d4, d5, 0 );
                 worldObj.spawnParticle("smoke", d, d1, d2, d3, d4, d5, 0);
             }
-            if(i1 > 0 && (Block.blocksList[i1].id == Blocks.GLASS.id
-                    ||  Block.blocksList[i1].blockMaterial == Material.topSnow
-                    ||  Block.blocksList[i1].blockMaterial == Material.plant
-                    ||  Block.blocksList[i1].blockMaterial == Material.web
-                    ||  Block.blocksList[i1].blockMaterial == Material.decoration
-                    ||  Block.blocksList[i1].blockMaterial == Material.ice))
+            if(i1 > 0 && (Blocks.blocksList[i1].id == Blocks.GLASS.id
+                    ||  Blocks.blocksList[i1].blockMaterial == Material.topSnow
+                    ||  Blocks.blocksList[i1].blockMaterial == Material.plant
+                    ||  Blocks.blocksList[i1].blockMaterial == Material.web
+                    ||  Blocks.blocksList[i1].blockMaterial == Material.decoration
+                    ||  Blocks.blocksList[i1].blockMaterial == Material.ice))
             {
-                Block.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
+                Blocks.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
                 worldObj.setBlockWithNotify(x, y, z, 0);
-                Block.blocksList[i1].onBlockDestroyedByExplosion(worldObj, x, y, z);
+                Blocks.blocksList[i1].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
         }
 
diff --git a/src/main/java/net/minecraft/core/world/PortalHandler.java b/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
similarity index 96%
rename from src/main/java/net/minecraft/core/world/PortalHandler.java
rename to game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
index 1b010846e..5a5c1cac2 100644
--- a/src/main/java/net/minecraft/core/world/PortalHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world;
 
 import net.minecraft.core.block.BlockPortal;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
@@ -73,7 +74,7 @@ public class PortalHandler
                         continue;
                     }
 
-                    if (portalColor != null && targetPortalId > 0 && ((BlockPortal)Block.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
+                    if (portalColor != null && targetPortalId > 0 && ((BlockPortal)Blocks.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
                         continue;
                     }
                     
@@ -108,7 +109,7 @@ public class PortalHandler
                             continue;
                         }
 
-                        if (portalColor != null && targetPortalId > 0 && ((BlockPortal) Block.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
+                        if (portalColor != null && targetPortalId > 0 && ((BlockPortal) Blocks.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
                             continue;
                         }
 
@@ -192,12 +193,12 @@ public class PortalHandler
         
         if (newDim.homeDim == null)
         {
-        	targetPortalFrameId = ((BlockPortal) Block.blocksList[oldDim.portalBlockId]).portalFrameId;
+        	targetPortalFrameId = ((BlockPortal) Blocks.blocksList[oldDim.portalBlockId]).portalFrameId;
         	targetPortalId = oldDim.portalBlockId;
         }
         else
         {
-        	targetPortalFrameId = ((BlockPortal)Block.blocksList[newDim.portalBlockId]).portalFrameId;
+        	targetPortalFrameId = ((BlockPortal)Blocks.blocksList[newDim.portalBlockId]).portalFrameId;
         	targetPortalId = newDim.portalBlockId;
         }
         
@@ -363,7 +364,7 @@ label1:
 
             }
             
-            ((BlockPortal)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ, portalColor);
+            ((BlockPortal)Blocks.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ, portalColor);
 
             world.noNeighborUpdate = false;
             for(int k6 = 0; k6 < 4; k6++)
diff --git a/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
similarity index 95%
rename from src/main/java/net/minecraft/core/world/World.java
rename to game/core/src/main/java/net/minecraft/core/world/World.java
index 87461f1dd..ea80c584b 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -446,7 +446,7 @@ public class World implements WorldSource {
 
     @Override
     public Block getBlock(int x, int y, int z) {
-        return Block.getBlock(getBlockId(x, y, z));
+        return Blocks.getBlock(getBlockId(x, y, z));
     }
 
     @Override
@@ -738,7 +738,7 @@ public class World implements WorldSource {
             return Material.air;
         } else
         {
-            return Block.blocksList[l].blockMaterial;
+            return Blocks.blocksList[l].blockMaterial;
         }
     }
 
@@ -772,7 +772,7 @@ public class World implements WorldSource {
             markBlockNeedsUpdate(x, y, z);
             int id = getBlockId(x, y, z);
             // TODO The name neighborNotifyOnMetadataChangeDisabled suggests that this should be inverted, but doing that breaks redstone
-            if(Block.neighborNotifyOnMetadataChangeDisabled[id & 0x3fff])
+            if(Blocks.neighborNotifyOnMetadataChangeDisabled[id & 0x3fff])
             {
                 notifyBlocksOfNeighborChange(x, y, z, id);
             }
@@ -883,7 +883,7 @@ public class World implements WorldSource {
         {
             return;
         }
-        Block block = Block.blocksList[getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block != null)
         {
             block.onNeighborBlockChange(this, x, y, z, blockId);
@@ -1024,9 +1024,9 @@ public class World implements WorldSource {
         else if(lightLayer == LightLayer.Block)
         {
             int i1 = getBlockId(x, y, z);
-            if(Block.lightEmission[i1] > lightValue)
+            if(Blocks.lightEmission[i1] > lightValue)
             {
-                lightValue = Block.lightEmission[i1];
+                lightValue = Blocks.lightEmission[i1];
             }
         }
         if(getSavedLightValue(lightLayer, x, y, z) != lightValue)
@@ -1141,17 +1141,17 @@ public class World implements WorldSource {
     @Nullable
     public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end)
     {
-        return checkBlockCollisionBetweenPoints(start, end, false, false);
+        return checkBlockCollisionBetweenPoints(start, end, false, false, false);
     }
 
     @Nullable
     public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids)
     {
-        return checkBlockCollisionBetweenPoints(start, end, shouldCollideWithFluids, false);
+        return checkBlockCollisionBetweenPoints(start, end, shouldCollideWithFluids, false, false);
     }
 
     @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks)
+    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes)
     {
         if(Double.isNaN(start.x) || Double.isNaN(start.y) || Double.isNaN(start.z))
         {
@@ -1169,10 +1169,14 @@ public class World implements WorldSource {
         int blockStartZ = MathHelper.floor(start.z);
         int id = getBlockId(blockStartX, blockStartY, blockStartZ);
         int meta = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
-        Block block = Block.blocksList[id];
-        if((!ignoreNonColliderBlocks || block == null || block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && id > 0 && (block.canCollideCheck(meta, shouldCollideWithFluids)))
-        {
-            HitResult hitResult = block.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
+        Block block = Blocks.blocksList[id];
+        if(
+            (
+                !ignoreNonColliderBlocks ||
+                    (block == null) ||
+                    ((useSelectorBoxes ? block.getSelectedBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) : block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ)) != null)) && (id > 0) && (block.canCollideCheck(meta, shouldCollideWithFluids)))
+        {
+            HitResult hitResult = block.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end, useSelectorBoxes);
             if(hitResult != null)
             {
                 return hitResult;
@@ -1305,9 +1309,10 @@ public class World implements WorldSource {
             }
             Block block1 = getBlock(blockStartX, blockStartY, blockStartZ);
             int metadata1 = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
-            if((!ignoreNonColliderBlocks || block1 == null || block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && block1 != null && block1.canCollideCheck(metadata1, shouldCollideWithFluids))
+            if(
+                (!ignoreNonColliderBlocks || (block1 == null) || ((useSelectorBoxes ? block1.getSelectedBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) : block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ)) != null)) && (block1 != null) && block1.canCollideCheck(metadata1, shouldCollideWithFluids))
             {
-                HitResult hitResult = block1.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
+                HitResult hitResult = block1.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end, useSelectorBoxes);
                 if(hitResult != null)
                 {
                     return hitResult;
@@ -1483,16 +1488,16 @@ public class World implements WorldSource {
     {
         listeners.remove(iworldaccess);
     }
-    public List<AABB> getCubes(Entity entity, AABB axisalignedbb)
+    public List<AABB> getCubes(Entity entity, AABB aabb)
     {
         collidingBoundingBoxes.clear();
 
-        int minX = MathHelper.floor(axisalignedbb.minX);
-        int maxX = MathHelper.floor(axisalignedbb.maxX + 1.0D);
-        int minY = MathHelper.floor(axisalignedbb.minY);
-        int maxY = MathHelper.floor(axisalignedbb.maxY + 1.0D);
-        int minZ = MathHelper.floor(axisalignedbb.minZ);
-        int maxZ = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
+        int minX = MathHelper.floor(aabb.minX);
+        int maxX = MathHelper.floor(aabb.maxX + 1.0D);
+        int minY = MathHelper.floor(aabb.minY);
+        int maxY = MathHelper.floor(aabb.maxY + 1.0D);
+        int minZ = MathHelper.floor(aabb.minZ);
+        int maxZ = MathHelper.floor(aabb.maxZ + 1.0D);
         for(int dx = minX - 1; dx <= maxX; dx++)
         {
             for(int dz = minZ - 1; dz <= maxZ; dz++)
@@ -1503,13 +1508,13 @@ public class World implements WorldSource {
                 }
                 for(int dy = minY - 1; dy <= maxY; dy++)
                 {
-                    Block block = Block.blocksList[getBlockId(dx, dy, dz)];
+                    Block block = getBlock(dx, dy, dz);
                     if(block != null)
                     {
                         int metadata = getBlockMetadata(dx, dy, dz);
                         if (block.collidesWithEntity(entity, this, dx, dy, dz) && entity.collidesWithBlock(block, metadata))
                         {
-                            block.getCollidingBoundingBoxes(this, dx, dy, dz, axisalignedbb, collidingBoundingBoxes);
+                            block.getCollidingBoundingBoxes(this, dx, dy, dz, aabb, collidingBoundingBoxes);
                         }
                     }
                 }
@@ -1519,11 +1524,11 @@ public class World implements WorldSource {
         }
 
         double radius = 0.25D;
-        List<Entity> list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.grow(radius, radius, radius));
-        for (Entity value : list) {
-            AABB axisalignedbb1 = value.getBb();
-            if (axisalignedbb1 != null && axisalignedbb1.intersects(axisalignedbb)) {
-                collidingBoundingBoxes.add(axisalignedbb1);
+        List<Entity> entities = getEntitiesWithinAABBExcludingEntity(entity, aabb.grow(radius, radius, radius));
+        for (Entity e : entities) {
+            AABB entityBB = e.getBb();
+            if (entityBB != null && entityBB.intersects(aabb)) {
+                collidingBoundingBoxes.add(entityBB);
             }
         }
 
@@ -1549,7 +1554,7 @@ public class World implements WorldSource {
                 }
                 for(int dy = minY - 1; dy <= maxY; dy++)
                 {
-                    Block block = Block.blocksList[getBlockId(dx, dy, dz)];
+                    Block block = Blocks.blocksList[getBlockId(dx, dy, dz)];
                     if(block != null && block.isSolidRender())
                     {
                         // ignore mesh blocks if entity is instance of an item
@@ -1616,7 +1621,7 @@ public class World implements WorldSource {
         while(y > 0)
         {
             int id = chunk.getBlockID(x, y, z);
-            Material material = id != 0 ? Block.blocksList[id].blockMaterial : Material.air;
+            Material material = id != 0 ? Blocks.blocksList[id].blockMaterial : Material.air;
             if(!material.blocksMotion() && !material.isLiquid())
             {
                 y--;
@@ -1637,7 +1642,7 @@ public class World implements WorldSource {
         z &= (Chunk.CHUNK_SIZE_Z - 1);
         while(y > 0)
         {
-            Block block = Block.getBlock(chunk.getBlockID(x, y, z));
+            Block block = Blocks.getBlock(chunk.getBlockID(x, y, z));
             Material material = block != null ? block.blockMaterial : Material.air;
             if(!material.blocksMotion())
             {
@@ -1674,7 +1679,7 @@ public class World implements WorldSource {
                 int id1 = getBlockId(entry.x, entry.y, entry.z);
                 if(id1 == entry.blockId && id1 > 0) {
                     immediatelyUpdatedPositions.add(entry);
-                    Block.blocksList[id1].updateTick(this, entry.x, entry.y, entry.z, rand);
+                    Blocks.blocksList[id1].updateTick(this, entry.x, entry.y, entry.z, rand);
                 }
             }
             return;
@@ -1883,7 +1888,7 @@ public class World implements WorldSource {
 		for(int x = minX; x <= maxX; x++) {
 			for(int y = minY; y <= maxY; y++) {
 				for(int z = minZ; z <= maxZ; z++) {
-					Block block = Block.blocksList[getBlockId(x, y, z)];
+					Block block = Blocks.blocksList[getBlockId(x, y, z)];
 					if(block != null) {
 						return true;
 					}
@@ -1915,7 +1920,7 @@ public class World implements WorldSource {
 		for(int x = minX; x <= maxX; x++) {
 			for(int y = minY; y <= maxY; y++) {
 				for(int z = minZ; z <= maxZ; z++) {
-					Block block = Block.blocksList[getBlockId(x, y, z)];
+					Block block = Blocks.blocksList[getBlockId(x, y, z)];
 					if(block != null && block.blockMaterial.isLiquid()) {
 						return true;
 					}
@@ -1951,7 +1956,7 @@ public class World implements WorldSource {
             {
                 for(int i2 = i1; i2 < j1; i2++)
                 {
-                    Block block = Block.blocksList[getBlockId(k1, l1, i2)];
+                    Block block = Blocks.blocksList[getBlockId(k1, l1, i2)];
                     if(block == null || !isMaterialInBB(aabb, material))
                     {
                         continue;
@@ -1975,21 +1980,21 @@ public class World implements WorldSource {
         return flag;
     }
 
-    public boolean isMaterialInBB(AABB axisalignedbb, Material ... materials)
+    public boolean isMaterialInBB(AABB aabb, Material ... materials)
     {
-        int minX_i = MathHelper.floor(axisalignedbb.minX);
-        int maxX_i = MathHelper.floor(axisalignedbb.maxX + 1.0D);
-        int minY_i = MathHelper.floor(axisalignedbb.minY);
-        int maxY_i = MathHelper.floor(axisalignedbb.maxY + 1.0D);
-        int minZ_i = MathHelper.floor(axisalignedbb.minZ);
-        int maxZ_i = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
+        int minX_i = MathHelper.floor(aabb.minX);
+        int maxX_i = MathHelper.floor(aabb.maxX + 1.0D);
+        int minY_i = MathHelper.floor(aabb.minY);
+        int maxY_i = MathHelper.floor(aabb.maxY + 1.0D);
+        int minZ_i = MathHelper.floor(aabb.minZ);
+        int maxZ_i = MathHelper.floor(aabb.maxZ + 1.0D);
         for(int _x = minX_i; _x < maxX_i; _x++)
         {
             for(int _y = minY_i; _y < maxY_i; _y++)
             {
                 for(int _z = minZ_i; _z < maxZ_i; _z++)
                 {
-                    Block block = Block.blocksList[getBlockId(_x, _y, _z)];
+                    Block block = Blocks.blocksList[getBlockId(_x, _y, _z)];
                     if(block != null) {
                         boolean isMaterial = false;
                         for (Material m : materials){
@@ -2000,10 +2005,7 @@ public class World implements WorldSource {
                         }
                         if (!isMaterial) continue;
 
-                        block.setBlockBoundsBasedOnState(this, _x, _y, _z);
-                        if (axisalignedbb.intersects(
-                            AABB.getTemporaryBB(_x + block.minZ, _y + block.minY, _z + block.minZ,
-                                _x + block.maxZ, _y + block.maxY, _z + block.maxZ))){
+                        if (aabb.intersects(block.getBlockBoundsFromState(this, _x, _y, _z).move(_x, _y, _z))){
                             return true;
                         }
 
@@ -2015,21 +2017,21 @@ public class World implements WorldSource {
         return false;
     }
 
-    public boolean isAABBInMaterial(AABB axisalignedbb, Material material)
+    public boolean isAABBInMaterial(AABB aabb, Material material)
     {
-        int i = MathHelper.floor(axisalignedbb.minX);
-        int j = MathHelper.floor(axisalignedbb.maxX + 1.0D);
-        int k = MathHelper.floor(axisalignedbb.minY);
-        int l = MathHelper.floor(axisalignedbb.maxY + 1.0D);
-        int i1 = MathHelper.floor(axisalignedbb.minZ);
-        int j1 = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
+        int i = MathHelper.floor(aabb.minX);
+        int j = MathHelper.floor(aabb.maxX + 1.0D);
+        int k = MathHelper.floor(aabb.minY);
+        int l = MathHelper.floor(aabb.maxY + 1.0D);
+        int i1 = MathHelper.floor(aabb.minZ);
+        int j1 = MathHelper.floor(aabb.maxZ + 1.0D);
         for(int k1 = i; k1 < j; k1++)
         {
             for(int l1 = k; l1 < l; l1++)
             {
                 for(int i2 = i1; i2 < j1; i2++)
                 {
-                    Block block = Block.blocksList[getBlockId(k1, l1, i2)];
+                    Block block = Blocks.blocksList[getBlockId(k1, l1, i2)];
                     if(block == null || block.blockMaterial != material)
                     {
                         continue;
@@ -2040,7 +2042,7 @@ public class World implements WorldSource {
                     {
                         d = (double)(l1 + 1) - (double)j2 / 8D;
                     }
-                    if(d >= axisalignedbb.minY)
+                    if(d >= aabb.minY)
                     {
                         return true;
                     }
@@ -2184,7 +2186,7 @@ public class World implements WorldSource {
     @Override
     public boolean isBlockOpaqueCube(int x, int y, int z)
     {
-        Block block = Block.blocksList[getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
@@ -2196,7 +2198,7 @@ public class World implements WorldSource {
 
     public boolean canPlaceOnSurfaceOfBlock(int x, int y, int z)
     {
-        Block block = Block.blocksList[getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
@@ -2209,7 +2211,7 @@ public class World implements WorldSource {
     @Override
     public boolean isBlockNormalCube(int x, int y, int z)
     {
-        Block block = Block.blocksList[getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
@@ -2222,7 +2224,7 @@ public class World implements WorldSource {
     public boolean canPlaceInsideBlock(int x, int y, int z) {
         int id = getBlockId(x, y, z);
 
-        return id == 0 || Block.getBlock(id).hasTag(BlockTags.PLACE_OVERWRITES);
+        return id == 0 || Blocks.getBlock(id).hasTag(BlockTags.PLACE_OVERWRITES);
     }
 
     public void onUnload()
@@ -2487,8 +2489,8 @@ public class World implements WorldSource {
                 int iBlockZ = (iRandVal / (Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (Chunk.CHUNK_SIZE_Z - 1);
                 int iBlockY = (iRandVal / (HEIGHT_BLOCKS * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (HEIGHT_BLOCKS - 1);
                 int id = chunk.getBlockID(iBlockX, iBlockY, iBlockZ);
-                if (Block.shouldTick[id]) {
-                    Block.blocksList[id].updateTick(this, iBlockX + chunkBlockX, iBlockY, iBlockZ + chunkBlockZ, rand);
+                if (Blocks.shouldTick[id]) {
+                    Blocks.blocksList[id].updateTick(this, iBlockX + chunkBlockX, iBlockY, iBlockZ + chunkBlockZ, rand);
                 }
                 i++;
             }
@@ -2524,7 +2526,7 @@ public class World implements WorldSource {
             int blockId = getBlockId(entry.x, entry.y, entry.z);
             if(blockId == entry.blockId && blockId > 0)
             {
-                Block.blocksList[blockId].updateTick(this, entry.x, entry.y, entry.z, rand);
+                Blocks.blocksList[blockId].updateTick(this, entry.x, entry.y, entry.z, rand);
             }
         }
 
@@ -2652,8 +2654,8 @@ public class World implements WorldSource {
     		return false;
     	}
         int j1 = getBlockId(x, y, z);
-        Block block = Block.blocksList[j1];
-        Block block1 = Block.blocksList[blockId];
+        Block block = Blocks.blocksList[j1];
+        Block block1 = Blocks.blocksList[blockId];
         AABB axisalignedbb = block1.getCollisionBoundingBoxFromPool(this, x, y, z);
         if(flag)
         {
@@ -3055,7 +3057,7 @@ public class World implements WorldSource {
         int j1 = getBlockId(x, y, z);
         if(j1 > 0)
         {
-            Block.blocksList[j1].triggerEvent(this, x, y, z, index, data);
+            Blocks.blocksList[j1].triggerEvent(this, x, y, z, index, data);
         }
     }
     
